function Buttons() {
    this.hintBtn = this.submitBtn = undefined;
    this.penaltyText = undefined;
    this.setView();
}

Buttons.prototype.setView = function() {
    this.hintBtn = new paper.Raster(variables.hintBtnImage);
    this.hintBtn.size.width = settings.BTN_WIDTH;
    this.hintBtn.size.height = variables.hintBtnImage.height * (this.hintBtn.size.width / variables.hintBtnImage.width);
    this.hintBtn.position = new paper.Point(settings.BTN_MARGIN + this.hintBtn.size.width / 2, constants.GAME_HEIGHT - 10 - this.hintBtn.size.height / 2);

    this.submitBtn = new paper.Raster(variables.submitBtnImage);
    this.submitBtn.size.width = settings.BTN_WIDTH;
    this.submitBtn.size.height = variables.submitBtnImage.height * (this.submitBtn.size.width / variables.submitBtnImage.width);
    this.submitBtn.position = new paper.Point(constants.GAME_WIDTH - settings.BTN_MARGIN - this.submitBtn.size.width / 2,
            constants.GAME_HEIGHT - 10 - this.submitBtn.size.height / 2);
}

Buttons.prototype.setHintClick = function() {
    this.hintBtn.visible = false;

    this.penaltyText = new paper.PointText({
        content: '-' + settings.HINT_PENALTY,
        fillColor: 'black',
        fontFamily: 'Times new roman',
        fontWeight: 'bold',
        fontSize: 25
    });
    this.penaltyText.position = new paper.Point(this.hintBtn.position.x, this.hintBtn.position.y);
}

Buttons.prototype.onFrame = function() {
    if(typeof(this.penaltyText) == "undefined") return;
    this.penaltyText.opacity -= 0.03;
    this.penaltyText.position.y -= 2;
    if(this.penaltyText.opacity < 0.05) this.clear();
}

Buttons.prototype.clear = function() {
    if(typeof(this.penaltyText) != "undefined") {
        this.penaltyText.remove();
        this.penaltyText = undefined;
    }
}

Buttons.prototype.submitIsClicked = function(clickPoint) {
    if(clickPoint.x > this.submitBtn.position.x - this.submitBtn.size.width / 2 && clickPoint.x < this.submitBtn.position.x
            + this.submitBtn.size.width / 2 && clickPoint.y > this.submitBtn.position.y - this.submitBtn.size.height / 2 &&
            clickPoint.y < this.submitBtn.position.y + this.submitBtn.size.height / 2) {
        return true;
    }
    return false;
}

Buttons.prototype.hintIsClicked = function(clickPoint) {
    if(clickPoint.x > this.hintBtn.position.x - this.hintBtn.size.width / 2 && clickPoint.x < this.hintBtn.position.x
            + this.hintBtn.size.width / 2 && clickPoint.y > this.hintBtn.position.y - this.hintBtn.size.height / 2 &&
            clickPoint.y < this.hintBtn.position.y + this.hintBtn.size.height / 2) {
        return true;
    }
    return false;
}