function Star(startX, startY) {
    this.startX = startX;
    this.startY = startY;
    this.targetX = this.targetPoint = this.targetY = this.speed = this.star = undefined;
    this.color = this.size = this.frameRotation = this.frameOpacity = undefined;
    this.setColor();
    this.setCoordinates();
    this.setView();
}

Star.prototype.setColor = function() {
    var red = Math.round(Math.random() * 255).toString(16);
    var green = Math.round(Math.random() * 255).toString(16);
    var blue = Math.round(Math.random() * 255).toString(16);
    this.color = "#fdf107";
}

Star.prototype.setCoordinates = function() {
    var angle = Math.round(Math.random() * 360);
    var distance = settings.STAR_FLIGHT_DISTANCE + Math.round(Math.random() * (settings.STAR_FLIGHT_VARIATIVITY * 2)) - settings.STAR_FLIGHT_VARIATIVITY;
    this.targetX = this.startX + distance * Math.cos(angle);
    this.targetY = this.startY + distance * Math.sin(angle);
    this.targetPoint = new paper.Point(this.targetX, this.targetY);
    this.speed = distance / (settings.STAR_TIME * 1000 / constants.MILISECONDS_FOR_FRAME);
}

Star.prototype.setView = function() {
    this.frameRotation = Math.round(Math.random() * 5) + 1;
    this.frameOpacity = (Math.round(Math.random() * 5) + 1) / 500;
    this.size = settings.STAR_SIZE + Math.round(Math.random() * (settings.STAR_SIZE_VARIATIVITY * 2)) - settings.STAR_SIZE_VARIATIVITY;

    var center = new paper.Point(this.startX, this.startY);
    var points = 5;
    var radius1 = this.size;
    var radius2 = this.size + 15;
    this.star = new paper.Path.Star(center, points, radius1, radius2);
    this.star.fillColor = this.color;
    this.star.rotate(Math.round(Math.random() * 360));
}

Star.prototype.onFrame = function() {
    this.star.rotate(this.frameRotation);
    this.star.opacity -= this.frameOpacity;

    var distance = this.star.position.getDistance(this.targetPoint);
    var L = this.speed / distance;
    var x = (1 - L) * this.star.position.x + L * this.targetPoint.x;
    var y = (1 - L) * this.star.position.y + L * this.targetPoint.y;
    this.star.position = new paper.Point(x, y);
}

Star.prototype.clear = function() {
    this.star.remove();
}