function VariantBlock(letter, index) {
    this.letter = letter;
    this.index = index;

    this.img = this.triangle = this.rect = this.visibleLetter = undefined;
    this.trianglePoint = undefined;
    this.currentAnswerBlock = undefined;
    this.setView();
}

VariantBlock.prototype.setView = function() {
    this.rect = new paper.Path.Rectangle(new paper.Point(0, 0), new paper.Size(variables.blockSize, variables.blockSize));
    this.rect.strokeWidth = 5;
    this.rect.strokeColor = settings.BLOCK_BORDER_COLOR;
    this.rect.fillColor = settings.VARIANT_FILL_COLOR;
    this.rect.position = new paper.Point(variables.leftRightMargin + variables.blockSize * this.index + settings.ANSWER_BLOCKS_MARGIN
            * this.index + variables.blockSize / 2, settings.ANSWER_MARGIN_TOP * 1.5 + variables.blockSize / 2 + variables.blockSize );

//    this.triangle = new paper.CompoundPath();
//    this.triangle.moveTo(0, 0);
//    this.triangle.lineTo(0, variables.blockSize / 5);
//    this.triangle.lineTo(variables.blockSize / 5, 0);
//    this.triangle.closePath();
//    this.triangle.fillColor = settings.TRIANGLE_FILL_COLOR;


    this.visibleLetter = new paper.PointText({
        content: this.letter,
        fillColor: settings.VARIANT_LETTER_COLOR,
        fontFamily: 'Times new roman',
        fontWeight: 'bold',
        fontSize: variables.blockSize / 10 * 5
    });

//    this.triangle.position.x = this.rect.position.x - variables.blockSize / 2 + variables.blockSize / 5 / 2;
//    this.triangle.position.y = this.rect.position.y - variables.blockSize / 2 + variables.blockSize / 5 / 2;
    this.visibleLetter.position = this.rect.position;

    var allGroup = new paper.Group([this.rect, this.visibleLetter]);
    this.img = allGroup.rasterize();

//    this.triangle.remove();
    this.rect.remove();
    this.visibleLetter.remove();
//    this.triangle = undefined;
    this.visibleLetter = undefined;
    this.rect = undefined;
}

VariantBlock.prototype.clear = function() {
    this.img.remove();
}

VariantBlock.prototype.move = function(currentPoint) {
    var targetX = currentPoint.x - objects.game.clickDifferenceX;
    var targetY = currentPoint.y - objects.game.clickDifferenceY;
    if(targetX > variables.leftLimit && targetX < variables.rightLimit) this.img.position.x = targetX;
    if(targetY > variables.topLimit && targetY < variables.bottomLimit) this.img.position.y = targetY;
    this.trianglePoint = new paper.Point(this.img.position.x - this.img.size.width / 2, this.img.position.y - this.img.size.height / 2);
//    $("#point_span").text("x = " + this.trianglePoint.x + "   y = " + this.trianglePoint.y);
}

VariantBlock.prototype.isClicked = function(clickPoint) {
    if(clickPoint.x > this.img.position.x - this.img.size.width / 2 && clickPoint.x < this.img.position.x
            + this.img.size.width / 2 && clickPoint.y > this.img.position.y - this.img.size.height / 2 &&
            clickPoint.y < this.img.position.y + this.img.size.height / 2) {
        return true;
    }
    return false;
}